#ifndef TEST_HPP             // FILE: test.hpp
#define TEST_HPP
/* RESULTADO
   Esta unidad es permite al programador desarrollar y probar
   programas de manera que pueda centrarse en sto sin necesidad
   de poner atencin al manejo del men para los casos de prueba.
   La informacin sobre cmo debe se usar esta unidad se encuentra
   detallada en el archivo  TEST.DOC.                                */
/* REQUIERE
   El mximo de opciones que pueden ser manejadas por esta unidad
   es 26.                                                            */
/* PROGRAMADOR
   Gustavo Alonso Sanabria Sanabria.
   Universidad de Costa Rica.
   Octubre de 1990                                                     */

#define bool  int
#define FALSE 0
#define TRUE  1

// Lneas para subrayado de ttulo
#define NO_LINE   0
#define DBL_LINE  ''
#define SNGL_LINE ''

typedef void (*option_proc)();  // procedimientos de opciones
typedef char str80_t[81];     	// largo mximo de mensaje de opciones
				// [81] = 0 !!!

// Procedimientos para manejo del men

void init_global();

void title   (const char*, unsigned char, char);
void say     (const char*);
bool display ();

void first_proc   (option_proc);
void last_proc    (option_proc);
void pre_menu     (option_proc);
void inter_menu   (option_proc);
void post_menu    (option_proc);
void force_option (option_proc, int = 1);
void add_option   (option_proc);

void gowork ();

// procedimientos miscelneos
void keydelay(int);
void beep();
void clrkeybuff();

#endif TEST_HPP
