// FILE: tools.hpp
/* RESULTADO
   Implementa herramientas utilitarias de programacin.  */
/* PROGRAMADORES
   Esteban Solis Quesada.
   Gustavo Sanabria Sanabria

   Universidad de Costa Rica                          	*/

#ifndef TOOLS_HPP
#define TOOLS_HPP

#include <conio.h>
#define bool  int
#define TRUE  1
#define FALSE 0

enum notes { C, CF, D, DF, E, F, FF, G, GF, A, AF, B };

inline char upcase(char ch)
/* RESULTADO
   Convierte ch a maysculas si est entre a y z. */
{ // upcase
  return ('a' <= ch) && ( ch <= 'z') ? (ch - 32) : (ch);
} // upcase

char readkey();
void keydelay(int = 5); // esperar 5 segundos por default
void clrkeybuf();
void play(notes,int);
void beep();
inline void error(const char *msg)
{
  cprintf("%s",msg);
  beep();
}


#endif