// FILE: usetest.cpp
/*RESULTADO
  Utiliza la unidad Test.pas para dar  un ejemplo sencillo
  del manejo del men principal de un programa. Se utiliza
  como ejemplo una pequea aplicacin que permite observar
  como es que trabaja la unidad antes mencionada.          */
/*PROGRAMADOR
  Gustavo Alonso Sanabria Sanabria                         */

#include "test.hpp"
#include "tools.hpp"
#include <conio.h>
#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <process.h>

int a, b;

void welcome()
/*RESULATDO
  Presenta el programa */
{ /* welcome */
  clrscr();
  gotoxy(10,10); cprintf("El siguiente el un ejemplo sencillo de como");
  gotoxy(10,11); cprintf("utilizar  la unidad test.cpp para el manejo");
  gotoxy(10,12); cprintf("y prueba de programas  que incluyen un men");
  gotoxy(10,15); cprintf("Presione cualquier tecla o espere 5 segundos");
  keydelay(5);
};  /* welcome */

void good_bye()
/*RESULTADO
  Despide el programa */
{ /* good_bye; */
  clrscr();
  gotoxy(10,10); cprintf("Esa ha sido toda la muestra..." );
  gotoxy(10,11); cprintf("Si ha sido de su gusto o no se agradece cualquier");
  gotoxy(10,12); cprintf("propuesta para llegar a mejorara la unidad test.cpp");
  gotoxy(10,15); cprintf("Atentamente");
  gotoxy(10,16); cprintf("Gustavo Alonso Sanabria Sanabria");
  gotoxy(10,20); cprintf("Presione cualquier tecla o espere 10 segundos");
  keydelay(10);
} /* good_bye; */

void before()
/*RESULTADO
  Da un mensaje que se va a entrar al men */
{ /* before */
  gotoxy(25,20);
  cprintf("\n\nSe entrar al men en 1 segundo");
  keydelay(1);
  clrscr();
} /* before */

void after()
/*RESULTADO
  Avisa que se ha salido del men. */
{ /* after */
  clrscr();
  gotoxy(25,20);
  cprintf("Se ha salido del men y de ejecutar una opcin");
  keydelay(1);
} /* after */

void add_ints()
/*RESULTADO
  Lee dos nmeros enteros y los suma. */
{ /* add_ints */
  if (display()) {
    say("Sumar dos enteros");
    return;
  }
  clrscr();
  cprintf("Digite el primer nmero: ");
  scanf("%d",&a);
  cprintf("\nDigite el segundo nmero: ");
  scanf("%d",&b);
  cprintf("\nSu suma es: %d\n\n", a + b);
  cprintf("Presione cualquier tecla");
  keydelay(5);
} /* add_ints */

void sub_ints()
/*RESULTADO
  Lee dos nmero enteros y los resta. */
{ /* sub_ints */
  if (display()) {
    say("Restar dos enteros");
    return;
  }
  clrscr();
  cprintf("Digite el primer nmero: ");
  scanf("%d",&a);
  cprintf("\nDigite el segundo nmero: ");
  scanf("%d",&b);
  cprintf("\nSu diferencia es: %d\n\n", a - b);
  cprintf("Presione cualquier tecla");
  keydelay(5);
} /* sub_ints */

void mult_ints()
/*RESULTADO
  Lee dos nmero reales y los multiplica */
{ /* mult_ints */
  if (display()) {
    say("Multiplicar dos enteros");
    return;
  }
  clrscr();
  cprintf("Digite el primer nmero: ");
  scanf("%d",&a);
  cprintf("\nDigite el segundo nmero: ");
  scanf("%d",&b);
  cprintf("\nSu producto es: %d\n\n", a * b);
  cprintf("Presione cualquier tecla");
  keydelay(5);
} /* mult_ints */

void div_reals()
/* RESULTADO
  Lee dos nmeros reales y los divide. */
{ /* div_reals */
  float x, y;
  if (display()) {
    say("Dividir dos reales");
    return;
  }
  clrscr();
  cprintf("Digite el primer nmero: ");
  scanf("%f",&x);
  cprintf("\nDigite el segundo nmero: ");
  scanf("%f",&y);
  cprintf("\nSu cociente es: %f\n\n", x / y);
  cprintf("Presione cualquier tecla");
  keydelay(5);
} /* div_reals */

void concat_str()
/*RESULTADO
  Lee tres tiras de caracteres y las concatena. */
{ /* concat_str */
  char str1[10], str2[10], str3[10], str4[30];
  if (display()) {
    say("Concatenar tres hileras");
    return;
  }
  clrscr();
  cprintf("Digite la primera tira: ");
  scanf("%s10",str1);
  cprintf("Digite la segunda tira: ");
  scanf("%s10",&str2);
  cprintf("Digite la tercera tira: ");
  scanf("%s10",&str3);
  strcpy(str4,str1);
  strcat(str4,str2);
  strcat(str4,str3);
  cprintf("Las tres tiras concatenadas son: %s\n\n",str4);
  cprintf("Presione cualquier tecla");
  keydelay(5);
} /* concat_str */

main()
{ /* usetest */
  init_global();
  first_proc(&welcome); /* se ejecuta una vez antes del men */
  pre_menu(&before);    /* se ejecuata antes de presentar el men en cad ciclo */
  post_menu(&after);    /* se ejecuta cada vez que sale de una opcin del men */

  title("Muestra del manejo de men", 7, SNGL_LINE);

  add_option(&add_ints);
  add_option(&sub_ints);
  add_option(&mult_ints);
  add_option(&div_reals);
  add_option(&concat_str);

/*  force_option(&add_ints, 3); /* suma dos enteros, se ejecuta 3 veces */
  last_proc(&good_bye);       /* se ejecuta una vez salido del men   */

  gowork();

/* el men queda inicializado, por lo que para volver a llamarlo hay */
/* que darle nuevamente los datos de opcin, etc.                    */

} /* usetest */